

#include <mach.h>
#include <servers/netname.h>
#include <mach_error.h>
#include <stdio.h>
#include <stdlib.h>
#include "random.h"

const char* gProgName = 0;

int main ( int argc, char* argv[] ) { 
	kern_return_t kr;
	mach_port_t ServerPort;
 
	gProgName = argv[0];
	kr = netname_look_up(name_server_port,
		"", "CounterServerPort",
		&ServerPort);
	if ( kr != KERN_SUCCESS ) {
		mach_error("netname_look_up(CounterServerPort)", kr);
		return 2;
	} 
#if 0
	{
		int number = 0;
		kr = get_random(ServerPort, &number);
		if ( kr == KERN_SUCCESS )
			printf("Result: %d\n", number);
		else 
			mach_error("get_random", kr);
	}
#endif

#if 1
	{
		string_ptr buff;
		kr = get_secret(ServerPort, buff);
		if ( kr == KERN_SUCCESS ) { 
			printf("%s\n", buff);
		} else { 
			mach_error("get_random", kr);
		}
	}
#endif
#if 1
	{
		string_ool_ptr password = 0;
		mach_msg_type_number_t passwordCnt = 0x000;
		
		kr = get_secret_ool(ServerPort,
				&password, &passwordCnt);
		if ( kr != KERN_SUCCESS )
			mach_error("get_secret_ool", kr);
		else { 
			printf("%s: Password_addr: %08x\n", 
					gProgName, (unsigned int)password);
			if ( password ) { 
				printf("%s: Password_data: %s\n", 
					gProgName, password);
			}
		}

		if ( password ) { 
			kr = vm_deallocate(mach_task_self(), 
					(vm_offset_t)password, passwordCnt);
			if ( kr != KERN_SUCCESS )
				mach_error("User:main:vm_deallocate", kr);
		}
	}
#endif

	return 0;
}

