


#include <stdio.h>
#include <mach.h>
#include <mach_error.h>
#include "random_types.h"
#include "random.h"

/* OK - this isn't very random, but we can pretend it is :-) */
kern_return_t get_random(mach_port_t serv_port, int *num) {
  static int count = 0;
  *num = (count++);
  return KERN_SUCCESS;
}


/* OK - this isn't very random either... */
kern_return_t get_secret(mach_port_t serv_port, 
		string_ptr password) { 
  static int count = 0;
  kern_return_t kr = KERN_SUCCESS;
  sprintf(password, "%d", count++);
  return kr;
}

/* And this... */
kern_return_t get_secret_ool( mach_port_t serv_port,
        string_ool_ptr *password,
        mach_msg_type_number_t *passwordCnt ) {
  kern_return_t kr = KERN_SUCCESS;
  vm_offset_t addr = 0;
  char data[] = "Hello, world";

  if ( !passwordCnt )
	printf("passwordCnt == 0\n");
  if ( !password )
	printf("password == 0\n");

  /*
   * Allocate the data for OOL transfers.
   *
   * Note that we don't free it here.  The MIG def for this 
   *   function, though, should have the dealloc flag paired
   *   with the password parameter, which, I believe, makes the
   *   MIG code deallocate it
   */
  *passwordCnt = strlen(data) + 1;
  kr = vm_allocate(mach_task_self(),
		&addr,
		*passwordCnt,
		1);
  if ( kr != KERN_SUCCESS ) {
	mach_error("get_secret_ool:vm_allocate", kr);
	return kr;
  }
  *password = (string_ool_ptr)addr;

  strcpy(*password, data);

  return kr;
}
